program allege;

uses crt;

var  nom_fich_source, nom_fich_destination, ligne: string;
     fichier_source, fichier_destination: text;
     abandon, existe: boolean;
     reponse: char;

{-----------------------}
procedure initialisation;
{-----------------------}
begin
     clrscr;
     gotoxy(8,10);
     write('A L L E G E M E N T   D '' U N   F I C H I E R   S A T E L L I T E');
     gotoxy(60,24);
     write('Taper une touche');
     reponse:=readkey;
end;

{--------------------}
procedure fich_existe;
{--------------------}
begin
     writeln('fichier   ',nom_fich_source,'   OUVERT');
     writeln;
     writeln;
     write('Nom du fichier destination --> ');
     readln(nom_fich_destination);
     assign(fichier_destination, nom_fich_destination);
     rewrite(fichier_destination);
     writeln;
     writeln('fichier   ',nom_fich_destination,'   OUVERT');
end;

{---------------------}
procedure fich_inconnu;
{---------------------}
begin
     writeln('fichier   ',nom_fich_source,'   INTROUVABLE');
     writeln;
     writeln;
     write('Voulez-vous essayer  nouveau (o/n) ? ');
     repeat
           reponse:=readkey;
     until reponse in ['o', 'n', 'O', 'N'];
     abandon:=reponse in ['n', 'N'];
end;

{------------------}
procedure ouverture;
{------------------}
begin
     if nom_fich_source<>''
        then begin
                  {$I-}
                  assign(fichier_source, nom_fich_source);
                  reset(fichier_source);
                  existe:=(IOresult=0);
                  {$I+}
                  if existe
                     then fich_existe
                     else fich_inconnu;
             end
        else abandon:=true;
end;

{-----------------------}
function saisie: boolean;
{-----------------------}
begin
     existe:=false;
     abandon:=false;
     while (not existe) and (not abandon) do
     begin
          clrscr;
          gotoxy(1, 10);
          write('Nom du fichier  alleger   --> ');
          readln(nom_fich_source);
          writeln;
          ouverture;
     end;
     saisie:=existe;
end;

{--------------------------------------------------}
function contient(phrase, extrait: string): boolean;
{--------------------------------------------------}
var i, j: integer;
    trouve: boolean;

begin
     j:=1;
     i:=1;
     trouve:=false;
     repeat
           if phrase[i]=extrait[j]
              then begin
                        j:=j+1;
                        trouve:=j>length(extrait);
                   end
              else begin
                        trouve:=false;
                        if j<>1 then begin i:=i-1;j:=1 end;
                   end;
           i:=i+1;
     until trouve or (i>length(phrase));
     contient:=trouve and (length(phrase)<>0);
end;

{----------------}
procedure ecremer;
{----------------}
begin
     writeln;
     writeln;
     writeln('PRET  allger, taper une touche ...');
     reponse:=readkey;
     clrscr;
     ligne:=' ';
     while (not eof(fichier_source)) and (not contient(ligne, '--')) do
     begin
          readln(fichier_source, ligne);
          writeln(ligne);
     end;
     while (not eof(fichier_source)) do
     begin
          readln(fichier_source, ligne);
          writeln(ligne);
          if not contient(ligne, '--')
             then writeln(fichier_destination, ligne);
     end;
     writeln;
     writeln;
     writeln;
     close(fichier_source);
     writeln('fichier   ', nom_fich_source,'   FERME');
     writeln;
     writeln;
     close(fichier_destination);
     writeln('fichier   ', nom_fich_destination,'   FERME');
     writeln;
     writeln;
end;

{------------}
procedure fin;
{------------}
begin
     writeln;
     writeln;
     writeln;
     writeln('allegement termin, taper une touche ...');
     reponse:=readkey;
     clrscr;
end;

{---------------------}
{ Programme principal }
{---------------------}
begin
     initialisation;
     if saisie then ecremer;
     fin;
end.
