program ANTENNE;

uses fonscal,wincrt;

var declin_magn,lat_station,long_station,long_sat:real;
    ch:char;
    azimut_magn,azimut_geog,elevation,Xsat,Ysat,Zsat,Xstat,Ystat,Zstat,D:real;
    Ux,Uy,Uz,Nx,Ny,Nz,Zx,Zy,Zz,El,k,Az,inclin_ini,El_vraie,X:real;
    nom_satellite:String;


BEGIN

writeln;writeln;
writeln('    CE PROGRAMME DONNE L''ORIENTATION D''UNE ANTENNE PARABOLIQUE');
writeln('                   Guiziou Robert Janvier 1996');
writeln;               
writeln('                       **************');
writeln;
write('     NOM DU SATELLITE :?');readln(nom_satellite);writeln;
write('     Donnez la latitude du lieu de rception () ? :');
readln(lat_station); writeln;

write('     Donnez la longitude du lieu de rception ()? :');
readln(long_station);  writeln;

write('     Donnez la longitude du satellite (>0 vers l''Est) ()? :');
readln(long_sat);writeln;

write('     Donnez la dclinaison magntique du lieu de rception ()? :');
readln(declin_magn);writeln;

write('     Donnez l''inclinaison initiale de l''antenne (environ 25)? :');
readln(inclin_ini);writeln;


{Coordonnes station dans le repre de Greenwich)]}

k:=pi/180;
declin_magn:= k*declin_magn;
lat_station:=k*lat_station;
long_station:=k*long_station;
long_sat:=k*long_sat;



Xstat:=6378*cos(lat_station)*cos(long_station);
Ystat:=6378*cos(lat_station)*sin(long_station);
Zstat:=6378*sin(lat_station);

{Coordonnes du satellite dans Greenwich}

Xsat:=42164*cos(long_sat);
Ysat:=42164*sin(long_sat);
Zsat:=0;


{Distance Station-Satellite}

D:=Sqrt((Xsat-Xstat)*(Xsat-Xstat)+(Ysat-Ystat)*(Ysat-Ystat)+(Zsat-Zstat)*(Zsat-Zstat));

{Vecteur unitaire station-Satellite}

Ux:= (Xsat-Xstat)/D;
Uy:= (Ysat-Ystat)/D;
Uz:= (Zsat-Zstat)/D;

{CALCUL AZIMUT ET ELEVATION}

{Vecteur Nord}

Nx:=  -sin(lat_station)*cos(long_station);
Ny:=  -sin(lat_station)*sin(long_station);
Nz:=   cos(lat_station);


{Vecteur Znith}

Zx:= cos(lat_station)*cos(long_station);
Zy:= cos(lat_station)*sin(long_station);
Zz:= sin(lat_station);


{Elvation}

El:=Arcsin(Ux*Zx+Uy*Zy+Uz*Zz)/k;

{Calcul de l'azimut magntique}

Az:=Arccos((Nx*Ux+Ny*Uy+Nz*Uz)/cos(El*k))/k;

If Long_sat<0 then
       begin
         Azimut_geog:=360-Az;
         Azimut_magn:=360-Az+declin_magn/k;
       End;
If Long_sat>=0 then
      Begin
        Azimut_geog:=Az;
        Azimut_magn:=Az+declin_magn/k;
      End;

El_vraie:=El-inclin_ini;
 




{RESULTATS}

writeln;
writeln('               *********************************************');
writeln('               *                  RESULTATS                * ');
writeln('               *********************************************');
writeln; writeln;
write('     VOICI LES RESULTATS POUR LE SATELLITE ',NOM_SATELLITE);
writeln;writeln;

write('     DISTANCE STATION-SATELLITE =',D:6:0,' Km'); writeln;
writeln;

write('     AZIMUT MAGNETIQUE =',Azimut_magn:6:2,' Degrs'); writeln;
writeln;
write('     AZIMUT GEOGRAHIQUE =',Azimut_geog:6:2,' Degrs');writeln;
writeln;
write('     ELEVATION ABSOLUE DE L''AXE ANTENNE OU DU SATELLITE =',El :6:2,' Degrs');writeln;
writeln;
write('     ELEVATION REELLE DE L''AXE ANTENNE =',El_vraie 	 :6:2,' Degrs environ');writeln;
writeln;
                                                             
Writeln('         NB: LA RECEPTION TOLERE EN GENERAL UN ECART DE 0.5  1'); Writeln;

write('                     APPUYER SUR UNE TOUCHE POUR QUITTER');
ch:=readkey;


donewincrt;

END.


