
				 {UNIT...UNIT...UNIT...UNIT...UNIT}

  UNIT DATES;

    {Cette unite ajoute ou complte les unites standards de turbo pascal des fonctions
    nouvelles et procedures nouvelles certaines generales d'autres concernant
    specialement le voyage interplantaire Terre Mars

    y:=DateSimple(x:real):STRING -->donne l'criture simplifiee de la date calendaire correspondant
		      la date julienne x  donnee en nombre reel , y est de type string
		     EXEMPLE : 20122001=DateSimple(719.03168982) soit le 20/12/2001

    y:=HeureSimple(x:real):STRING -->donne l'criture simplifiee de l heure dans le jour correspondant
		      la date julienne x  donnee en nombre reel , y est de type string
		     EXEMPLE : 124538=DateSimple(719.03168982) soit  12 h 45 mn 38 s

    y:=DateNormale(x:real):STRING --> donne la date sous forme classique JJ/MM/AAAA lorsqu'on entre la
		     date julienne fractionnaire. Sortie de type string

    y:=HeureDecimale(x:real):REAL -->donne l heure dans le jour sous forme dcimale lorsqu'on entre la
		     date julienne du jour en rel partie entiere et fractionnaire.

    y=JourJuli(x1,x2:string):REAL ---> donne la date julienne lorsqu on fournit la date calendaire x1 sous la
		     forme  simplifiee STRING  6 caractres (EX : 23 dcembre 99-->x1=23121999) et l heure
		     simplifiee x2 STRING ( EX : 15 h 45 mn 56 s --->x2=154546 )

		     EXEMPLE Jourjuli('22102002','124556'))= 1025.0318981
		     LE 22 OCTOBRE 2002  12 h 45 mn 56 s  est le Jour Julien 1025.0318981

    }
      INTERFACE

       uses Wincrt;

  { ***** FONCTIONS *****}

       function DateSimple(x:real):string;
       function HeureSimple(x:real):string;
       function JourJuli(x1,x2:string):real;
       function DateNormale(x:real):string;
       function HeureDecimale(x:real):real;

  { ***** PROCEDURES *****}



      IMPLEMENTATION

      { ------------------------------ DateSimple -----------------------------------------}

      Function DateSimple(x:real):string;



	type tableau12=array[0..11] of integer;

	const nonbis:tableau12 =(31,59,90,120,151,181,212,243,273,304,334,365);
			bis:tableau12=(31,60,91,121,152,182,213,244,274,305,335,366);
			numeroJourNonbis:tableau12=(31,28,31,30,31,30,31,31,30,31,30,31);
			numeroJourbis:tableau12=(31,29,31,30,31,30,31,31,30,31,30,31);

	VAR datejuli,joursrestants,temps:real;
		TotalJourMois,numero:tableau12;
		ch:char;
		bissex,i,k,annee,mois,jourmois,heure,minute,reste,
		seconde:integer;
		AnneeJulienne:Array[1980..2020] of real;
		JourDate,MoisDate,AnneeDate:String;

	BEGIN
	datejuli:=x;

	{Calcul de la date julienne des annees 1980  2020 , on rappelle
	que le 01/01/2000 a 12 h est le jour julien 0}

	AnneeJulienne[1980]:= -7305.5;

	For i:=1 to 40 do

		Begin

			{Test de l annee bissextile}

			If ((1980+i-1) MOD(4))=0 then bissex:=1 else bissex:=0;

			 AnneeJulienne[1980+i]:=AnneeJulienne[1980+i-1]+365+BISSEX;

		End;
	{Calcul preliminaire de la date julienne a zero heure}


	 {Calcul de l annee}

	For i:=1 to 39 do

		Begin

		if datejuli=AnneeJulienne[1980+i]+0.5 then
		 begin
			annee:=1980+i;
			k:=i;
		 end;

		If (datejuli<(AnneeJulienne[1980+i+1]+0.5)) and (datejuli>(AnneeJulienne[1980+i]+0.5))
		then
			 begin
			 annee:=1980+i;
			 k:=i;
		end;

		If datejuli=AnneeJulienne[2020]+0.5 then
			begin
				annee:=2020;
				k:=40;
			end;

	End;

	{Calcul du mois de l annee}

	JoursRestants:=Round(Int(datejuli-AnneeJulienne[1980+k]));


	If (annee MOD(4)=0) then
	begin
		TotalJourMois:=bis;
		numero:=numeroJourbis;
	end

										else
	begin
		TotalJourMois:=nonbis;
		numero:=numeroJournonbis;
	end;

	mois:=1;
	for i:=0 to 10 do

	begin

		if (JoursRestants<TotalJourMois[0])  then

			begin
				mois:=1;
				reste:=round(JoursRestants)+1;
			end;

		if JoursRestants=TotalJourMois[i] then
     begin
			 mois:=i+2;
			 reste:=1;
		 end;

		if (JoursRestants>TotalJourMois[i]) and (JoursRestants<TotalJourMois[i+1])
		then
      begin
			 mois:=i+2;
			 reste:=round(JoursRestants-TotalJourMois[i])+1;
      end;

		if (JoursRestants=TotalJourMois[i+1]) then
     begin
			mois:=i+2;
			reste:=numero[i];
		 end;

	end;

	 {Calcul de l heure }

	temps:=frac(datejuli-0.5);
	if temps<0 then temps:=temps+1;

	 heure:=round(Int(temps*24));
	 temps:=(temps*24-heure)*60;
	 minute:=round(Int(temps));
	 temps:=(temps-minute)*60;
	 seconde:=round(temps);


	 str(reste,JourDate);  str(mois,MoisDate);   str(annee,AnneeDate);
	if (datejuli+0.5)*datejuli<0   then

	begin
	  DateSimple:='31121999'
	end;
	 if (datejuli+0.5)*datejuli>0then
	begin
	 if length(JourDate)<2 then JourDate:='0'+JourDate;
	 if length(MoisDate)<2 then MoisDate:='0'+MoisDate;

	 DateSimple:=JourDate+ MoisDate+AnneeDate;
	 end;


     END;

    { -------------------------------- HeureSimple -----------------------------------------}

     function HeureSimple(x:real):string;


	type tableau12=array[0..11] of integer;

	const nonbis:tableau12 =(31,59,90,120,151,181,212,243,273,304,334,365);
			bis:tableau12=(31,60,91,121,152,182,213,244,274,305,335,366);
			numeroJourNonbis:tableau12=(31,28,31,30,31,30,31,31,30,31,30,31);
			numeroJourbis:tableau12=(31,29,31,30,31,30,31,31,30,31,30,31);

	VAR datejuli,joursrestants,temps:real;
		TotalJourMois,numero:tableau12;
		ch:char;
		bissex,i,k,annee,mois,jourmois,heure,minute,reste,
		seconde:integer;
		AnneeJulienne:Array[1980..2020] of real;
		HeureDate,MinuteDate,SecondeDate:String;

	BEGIN
	datejuli:=x;

	{Calcul de la date julienne des annees 1980  2020 , on rappelle
	que le 01/01/2000 a 12 h est le jour julien 0}

	AnneeJulienne[1980]:= -7305.5;

	For i:=1 to 40 do

		Begin

			{Test de l annee bissextile}

			If ((1980+i-1) MOD(4))=0 then bissex:=1 else bissex:=0;

			 AnneeJulienne[1980+i]:=AnneeJulienne[1980+i-1]+365+BISSEX;

		End;
	{Calcul preliminaire de la date julienne a zero heure}


	 {Calcul de l annee}

	For i:=1 to 39 do

		Begin

		if datejuli=AnneeJulienne[1980+i]+0.5 then
		 begin
			annee:=1980+i;
			k:=i;
		 end;

		If (datejuli<(AnneeJulienne[1980+i+1]+0.5)) and (datejuli>(AnneeJulienne[1980+i]+0.5))
		then
			 begin
			 annee:=1980+i;
			 k:=i;
		end;

		If datejuli=AnneeJulienne[2020]+0.5 then
			begin
				annee:=2020;
				k:=40;
			end;

	End;

	{Calcul du mois de l annee}

	JoursRestants:=Round(Int(datejuli-AnneeJulienne[1980+k]));


	If (annee MOD(4)=0) then
	begin
		TotalJourMois:=bis;
		numero:=numeroJourbis;
	end

										else
	begin
		TotalJourMois:=nonbis;
		numero:=numeroJournonbis;
	end;

	mois:=1;
	for i:=0 to 10 do

	begin

		if (JoursRestants<TotalJourMois[0])  then

			begin
				mois:=1;
				reste:=round(JoursRestants)+1;
			end;

		if JoursRestants=TotalJourMois[i] then
     begin
			 mois:=i+2;
			 reste:=1;
		 end;

		if (JoursRestants>TotalJourMois[i]) and (JoursRestants<TotalJourMois[i+1])
		then
      begin
			 mois:=i+2;
			 reste:=round(JoursRestants-TotalJourMois[i])+1;
      end;

		if (JoursRestants=TotalJourMois[i+1]) then
     begin
			mois:=i+2;
			reste:=numero[i];
		 end;

	end;

	 {Calcul de l heure }

	temps:=frac(datejuli-0.5);
	if temps<0 then temps:=temps+1;

	 heure:=round(Int(temps*24));
	 temps:=(temps*24-heure)*60;
	 minute:=round(Int(temps));
	 temps:=(temps-minute)*60;
	 seconde:=round(temps);

	 

	 str(heure,HeureDate);  str(minute,MinuteDate);   str(seconde,SecondeDate);

	 if length(HeureDate)<2 then HeureDate:='0'+HeureDate;
	 if length(MinuteDate)<2 then MinuteDate:='0'+MinuteDate;
	 if length(SecondeDate)<2 then SecondeDate:='0'+SecondeDate;

	 HeureSimple:=HeureDate+ MinuteDate+SecondeDate;



     END;

   {------------------------------ JOURJULI -----------------------------------------}

  function JourJuli(x1,x2:string):real;

    const jourmois:array[1..12]of real=(0,31,59,90,120,151,181,212,243,
		273,304,334);


    var jour,mois,annee,h,mn,s:integer;
	chnj,datir,heure:string;
	erreur,x:integer;
	ajour,bis,JJ2000:real;

       {Annonces preliminaires}
       {Cette procedure donne la date julienne
	 pour les annees 1900  2099 incluses
	   Le resultat est exprime e jours juliens origine le 01/01/2000  12 h:variable JJ2000}


	Begin

	datir:=x1;heure:=x2;
	 {Analyse de la date}

	 chnj:=copy(datir,1,2);
	 val(chnj,jour,erreur);
	 chnj:=copy(datir,3,2);
	 val(chnj,mois,erreur);
	 chnj:=copy(datir,5,4);
	 val(chnj,annee,erreur);

	 {Lecture et analyse de l'heure,tests de conformit'}

	   chnj:=copy(heure,1,2);
	   val(chnj,h,erreur);
	   chnj:=copy(heure,3,2);
	   val(chnj,mn,erreur);
	   chnj:=copy(heure,5,2);
	   val(chnj,s,erreur);

	  {Calcul des dates juliennes}

      {MJ:millenaire,SJ:siecle,JJ2000:jours nouveaux,JJANCIEN:jours anciens}



	x:=annee mod 4;
	if x<>0 then ajour:=jour
		else if(mois<3) then ajour:=jour
				else ajour:=jour+1;
	ajour:=ajour+jourmois[mois];

	case x of
	     0:bis:=0;
	     1:bis:=0.75;
	     2:bis:=0.5;
	     3:bis:=0.25;
	end;

	JJ2000:=ajour+(annee-2000)*365.25-1.5+(h+mn/60+s/3600)/24+bis;

	Jourjuli:=JJ2000;

      end;


  { ------------------------------ DateNormale ----------------------------------- }

   function DateNormale(x:real):string;

      type tableau12=array[0..11] of integer;

	const nonbis:tableau12 =(31,59,90,120,151,181,212,243,273,304,334,365);
			bis:tableau12=(31,60,91,121,152,182,213,244,274,305,335,366);
			numeroJourNonbis:tableau12=(31,28,31,30,31,30,31,31,30,31,30,31);
			numeroJourbis:tableau12=(31,29,31,30,31,30,31,31,30,31,30,31);

	VAR datejuli,joursrestants,temps:real;
		TotalJourMois,numero:tableau12;
		ch:char;
		bissex,i,k,annee,mois,jourmois,heure,minute,reste,
		seconde:integer;
		AnneeJulienne:Array[1980..2020] of real;
		JourDate,MoisDate,AnneeDate:String;

	BEGIN
	datejuli:=x;

	{Calcul de la date julienne des annees 1980  2020 , on rappelle
	que le 01/01/2000 a 12 h est le jour julien 0}

	AnneeJulienne[1980]:= -7305.5;

	For i:=1 to 40 do

		Begin

			{Test de l annee bissextile}

			If ((1980+i-1) MOD(4))=0 then bissex:=1 else bissex:=0;

			 AnneeJulienne[1980+i]:=AnneeJulienne[1980+i-1]+365+BISSEX;

		End;
	{Calcul preliminaire de la date julienne a zero heure}


	 {Calcul de l annee}

	For i:=1 to 39 do

		Begin

		if datejuli=AnneeJulienne[1980+i]+0.5 then
		 begin
			annee:=1980+i;
			k:=i;
		 end;

		If (datejuli<(AnneeJulienne[1980+i+1]+0.5)) and (datejuli>(AnneeJulienne[1980+i]+0.5))
		then
			 begin
			 annee:=1980+i;
			 k:=i;
		end;

		If datejuli=AnneeJulienne[2020]+0.5 then
			begin
				annee:=2020;
				k:=40;
			end;

	End;

	{Calcul du mois de l annee}

	JoursRestants:=Round(Int(datejuli-AnneeJulienne[1980+k]));


	If (annee MOD(4)=0) then
	begin
		TotalJourMois:=bis;
		numero:=numeroJourbis;
	end

										else
	begin
		TotalJourMois:=nonbis;
		numero:=numeroJournonbis;
	end;

	mois:=1;
	for i:=0 to 10 do

	begin

		if (JoursRestants<TotalJourMois[0])  then

			begin
				mois:=1;
				reste:=round(JoursRestants)+1;
			end;

		if JoursRestants=TotalJourMois[i] then
     begin
			 mois:=i+2;
			 reste:=1;
		 end;

		if (JoursRestants>TotalJourMois[i]) and (JoursRestants<TotalJourMois[i+1])
		then
      begin
			 mois:=i+2;
			 reste:=round(JoursRestants-TotalJourMois[i])+1;
      end;

		if (JoursRestants=TotalJourMois[i+1]) then
     begin
			mois:=i+2;
			reste:=numero[i];
		 end;

	end;

	 {Calcul de l heure }

	temps:=frac(datejuli-0.5);
	if temps<0 then temps:=temps+1;

	 heure:=round(Int(temps*24));
	 temps:=(temps*24-heure)*60;
	 minute:=round(Int(temps));
	 temps:=(temps-minute)*60;
	 seconde:=round(temps);


	 str(reste,JourDate);  str(mois,MoisDate);   str(annee,AnneeDate);
	if (datejuli+0.5)*datejuli<0   then

	begin
	  DateNormale:='31/12/1999'
	end;
	 if (datejuli+0.5)*datejuli>0then
	begin
	 if length(JourDate)<2 then JourDate:='0'+JourDate;
	 if length(MoisDate)<2 then MoisDate:='0'+MoisDate;

	 DateNormale:=JourDate+'/'+ MoisDate+'/'+AnneeDate;
	 end;


     END;
 { ------------------------------- HeureDecimale ---------------------------------}

   function HeureDecimale(x:real):real;

	 type tableau12=array[0..11] of integer;

	const nonbis:tableau12 =(31,59,90,120,151,181,212,243,273,304,334,365);
			bis:tableau12=(31,60,91,121,152,182,213,244,274,305,335,366);
			numeroJourNonbis:tableau12=(31,28,31,30,31,30,31,31,30,31,30,31);
			numeroJourbis:tableau12=(31,29,31,30,31,30,31,31,30,31,30,31);

	VAR datejuli,joursrestants,temps:real;
		TotalJourMois,numero:tableau12;
		ch:char;
		bissex,i,k,annee,mois,jourmois,heure,minute,reste,
		seconde:integer;
		AnneeJulienne:Array[1980..2020] of real;
		JourDate,MoisDate,AnneeDate:String;

	BEGIN
	datejuli:=x;

	{Calcul de la date julienne des annees 1980  2020 , on rappelle
	que le 01/01/2000 a 12 h est le jour julien 0}

	AnneeJulienne[1980]:= -7305.5;

	For i:=1 to 40 do

		Begin

			{Test de l annee bissextile}

			If ((1980+i-1) MOD(4))=0 then bissex:=1 else bissex:=0;

			 AnneeJulienne[1980+i]:=AnneeJulienne[1980+i-1]+365+BISSEX;

		End;
	{Calcul preliminaire de la date julienne a zero heure}


	 {Calcul de l annee}

	For i:=1 to 39 do

		Begin

		if datejuli=AnneeJulienne[1980+i]+0.5 then
		 begin
			annee:=1980+i;
			k:=i;
		 end;

		If (datejuli<(AnneeJulienne[1980+i+1]+0.5)) and (datejuli>(AnneeJulienne[1980+i]+0.5))
		then
			 begin
			 annee:=1980+i;
			 k:=i;
		end;

		If datejuli=AnneeJulienne[2020]+0.5 then
			begin
				annee:=2020;
				k:=40;
			end;

	End;

	{Calcul du mois de l annee}

	JoursRestants:=Round(Int(datejuli-AnneeJulienne[1980+k]));


	If (annee MOD(4)=0) then
	begin
		TotalJourMois:=bis;
		numero:=numeroJourbis;
	end

										else
	begin
		TotalJourMois:=nonbis;
		numero:=numeroJournonbis;
	end;

	mois:=1;
	for i:=0 to 10 do

	begin

		if (JoursRestants<TotalJourMois[0])  then

			begin
				mois:=1;
				reste:=round(JoursRestants)+1;
			end;

		if JoursRestants=TotalJourMois[i] then
     begin
			 mois:=i+2;
			 reste:=1;
		 end;

		if (JoursRestants>TotalJourMois[i]) and (JoursRestants<TotalJourMois[i+1])
		then
      begin
			 mois:=i+2;
			 reste:=round(JoursRestants-TotalJourMois[i])+1;
      end;

		if (JoursRestants=TotalJourMois[i+1]) then
     begin
			mois:=i+2;
			reste:=numero[i];
		 end;

	end;

	 {Calcul de l heure }

	temps:=frac(datejuli-0.5);
	if temps<0 then temps:=temps+1;

	 heure:=round(Int(temps*24));
	 temps:=(temps*24-heure)*60;
	 minute:=round(Int(temps));
	 temps:=(temps-minute)*60;
	 seconde:=round(temps);

	 HeureDecimale:=heure+minute/60+seconde/3600;
	

     END;

    
END.

   { *************************************   FIN DES FONCTIONS  *************************
    Guiziou Robert Janvier 2000}