




                  {UNIT...UNIT...UNIT...UNIT...UNIT}

  unit fonscal;

    {Cette unite ajoute aux unites standards de turbo pascal des fonctions
    nouvelles:Arcsin,Arccos,tan et les fonctions hyperboliques cosh,sinh ainsi
    que argsh,argch,argth }

      INTERFACE
       function tan(x:real):real;
       function arcsin(x:real):real;
       function arccos(x:real):real;
       function cosh(x:real):real;
       function sinh(x:real):real;
       function argsh(x:real):real;
       function argch(x:real):real;
       function argth(x:real):real;

      IMPLEMENTATION

        function tan(x:real):real;
         var u:real;
          begin
           if (abs(cos(x))<1e-8)
                   then write('la tangente de l angle est infinie')
                   else
                       begin
                        u:=sin(x)/cos(x);
                        tan:=u;
                       end;
          end;

       function arcsin(x:real):real;
         var u:real;
          begin
           if(abs(x)<(1-1e-6))
                   then u:=arctan(sqrt(x*x/(1-x*x)))
                   else if((abs(abs(x)-1))<1e-6)
                        then u:=pi/2
                        else writeln('Argument de arccos invalide');

           if(x>=0) then arcsin:=u
                    else arcsin:=-u;
      end;

      function arccos(x:real):real;
        var u:real;
         begin
          if ((abs(x)<=(1-1e-6)) and (abs(x)>=1e-6))
                  then u:=arctan(sqrt(1/x/x-1))
                  else if (abs((abs(x)-1))<1e-6)
                       then u:=0
                       else if abs(x)<1e-6
                            then u:=pi/2;
          if (x>0) then arccos:=u
                   else arccos:=pi-u;
         end;

       function cosh(x:real):real;
         var u:real;
         begin
          u:=0.5*(exp(x)+exp(-x));
          cosh:=u;
         end;

        function sinh(x:real):real;
          var u:real;
          begin
           u:=0.5*(exp(x)-exp(-x));
           sinh:=u;
          end;

        function argsh(x:real):real;
          var u:real;
          begin
            u:=ln(x+sqrt(x*x+1));
            argsh:=u;
          end;

        function argch(x:real):real;
          var u:real;
          begin
            u:=ln(x+sqrt(x*x-1));
            argch:=u;
          end;
        function argth(x:real):real;
         var u:real;
          begin
           if(abs(x)>1)
                then write('Argument de argth >1')
                else if (x>0)
                         then u:=argch(sqrt(1/(1-x*x)))
                         else u:=-argch(sqrt(1/(1-x*x)));

           argth:=u;
          end;
    end.






