program visi_sat;

 uses wincrt;

 type tableau400=array[1..400] of real;

 var fich,fichier,fichierexcel:text;
     x,elevation,date,heure1,heure2,duree,heuresat,nomsatellite,xelevmin:string;
     i,k,longueur,erreur,j,repetitivite:integer;
     ch:char;
     elev,dureeliaison,elevmin,dureemin:real;
     ligne:array[1..50] of string;
     moyenne,tableur:real;
     nom_fichier,fichierdisque,nombase,nom_fichier_tableur,xduree:string;
     comm:array[1..400] of real;
     data1,data2:string;

        PROCEDURE ouverture(nom_fichier:string);

         BEGIN
              {Ouverture du fichier a traiter}

              assign(fich,nom_fichier);
              reset(fich);

         END;


         PROCEDURE ouverturetableur(nom_fichier_tableur:string);

         BEGIN
              {Ouverture du fichier tableur a traiter}

              assign(fichierexcel,nom_fichier_tableur);
              reset(fichierexcel);

         END;


      PROCEDURE TEMPS (var heure1,heure2,duree:string;var dureeliaison:real);

      var h1,h2,mn1,mn2,s1,s2,dureecomm:real;
          x:string;
          erreur:integer;

       BEGIN

            x:=copy(heure1,2,2);
            val(x,h1,erreur);
            x:=copy(heure2,2,2);
            val(x,h2,erreur);
            x:=copy(heure1,5,2);
            val(x,mn1,erreur);
            x:=copy(heure2,5,2);
            val(x,mn2,erreur);
            x:=copy(heure1,8,2);
            val(x,s1,erreur);
            x:=copy(heure2,8,2);
            val(x,s2,erreur);

            if h2<h1 then h2:=24;

            dureecomm:= (h2-h1)*60.+mn2-mn1+(s2-s1)/60.;

            str(dureecomm:3:2,duree);

            dureeliaison:=(h2-h1)*3600+(mn2-mn1)*60+s2-s1;

  END;
       PROCEDURE elevation_acceptable;

       label RETOUR;

        BEGIN

           for i:=1 to 16 do

            Begin
              readln(fich,x);

              if i=11 then
                 begin
                      data1:=copy(x,1,74);

                      Writeln(fichier);
                      writeln(fichier,'   DONNEES SATELLITE AU FORMAT NASA:');
                      writeln(fichier);
                      writeln(fichier,data1);
                 end;

              if i=12 then
               begin
                      data2:=copy(x,1,74);
                      writeln(fichier,data2);
                      writeln(fichier);
                 end

            end;


         i:=1;
         k:=0;

        while not(eof(fich)) do


        begin

             j:=0;

             RETOUR:readln(fich,x);

             if copy(x,31,2)='--' then  goto RETOUR;

             elevation:=copy(x,27,5);
             val(elevation,elev,erreur);


             if (elev>=elevmin)
                then
                  begin

                   ligne[i]:=x;


                       if i=2 then
                          begin
                               writeln(fichier);
                               writeln(fichier,'     ------------------------------------------------------------------');
                               date:=copy(x,1,8);

                               writeln(fichier,'       DATE: ',date);

                          end;

                    i:=i+1;
                 end;

             if (elev<elevmin) and (i=2) then i:=1;

             if (elev<elevmin) and (i>=3)
                 then
                        begin
                             writeln(fichier);
                             writeln(fichier,'                 HEURES');
                             heure1:=copy(ligne[1],9,9);
                             heure2:=copy(ligne[i-1],9,9);
                             writeln(fichier,'                     Debut de liaison--->',heure1);
                             writeln(fichier,'                     Fin de liaison----->',heure2);
                             writeln;

                             TEMPS(heure1,heure2,duree,dureeliaison);
                             writeln(fichier,'                                 DUREE DE LA LIAISON:----> ',duree ,' minutes');
                             writeln(fichier);

                             comm[k]:=dureeliaison;

                             if dureeliaison>=dureemin then
                             begin
                                  str(dureeliaison:4:0,xduree);

                                  writeln(fichierexcel,date,chr(9),heure1,chr(9),heure2,chr(9),xduree);
                             end;

                             k:=k+1;
                             writeln('                         JE TRAVAILLE POUR VOUS!!!!!');
                             writeln(fichier,'     --------------------------------------------------------------------');
                             i:=1;
                        end;


         end;

      END;

  PROCEDURE CONTACTMOYEN;


   var dureecontactjour:real;
       t1,t2:string;

     BEGIN

        moyenne:=0;

        for i:=1 to k do


            begin
                 moyenne:=moyenne+comm[i];
            end;

        moyenne:=moyenne/k;
        str(moyenne:5:0,t1);
        writeln(fichier);
        writeln(fichier,' ************************************************************************');
        writeln(fichier,'  Duree moyenne de la liaison: ',t1,' secondes par liaison');
        writeln(fichier);

        dureecontactjour:=moyenne*k/repetitivite;
        str(dureecontactjour:6:0,t2);

        writeln(fichier,'  Duree moyenne du contact par jour: ',t2,' secondes');

   END;

  PROCEDURE DIALOGUE;



  BEGIN

  write('   Quel est le nom de votre satellite --->');Readln(nomsatellite);
  writeln;
  write('   A quelle heure est-il place par rapport au soleil? --->');
  readln(heuresat);
  writeln;

  write('   Donnez le nom du fichier  traiter: ');
  readln(nom_fichier);

  writeln;
  write('   Chemin et nom du fichier disque des resultats: ');
  readln(fichierdisque);
  writeln;
  write('   Chemin et nom du fichier disque pour tableur: ');
  readln(nom_fichier_tableur);
  writeln;
  write('   Donnez en jours la repetitivite: ');
  readln(repetitivite);
  writeln;
  write('   Donnez le nom de la station de poursuite :');
  readln(nombase);
  writeln;
  write('   Elevation minimale de visibilite  en degres pour TM-TC :');
  readln(elevmin);
  writeln;
  write('   Donnez la duree minimale de communication souhaitee(en secondes): ');Readln(dureemin);
  writeln;writeln;writeln;

  writeln('                     LAISSEZ TRAVAILLER LA MACHINE');
  writeln('                    Appuyez une touche pour lancer et arreter');
  ch:=readkey;
    END;



  PROCEDURE ECRITUREDISQUE;

  var elevmintexte:string;

  BEGIN

       ASSIGN(fichier,fichierdisque);
       REWRITE(fichier);

       assign(fichierexcel,nom_fichier_tableur);
       rewrite(fichierexcel);
       

       Writeln(fichier,'                              SATELLITE: ',nomsatellite);
       writeln(fichier);
       writeln(fichier,'                             HELIOSYNCHRONE ',heuresat,' heures');
       writeln(fichier);
       writeln(fichier,'                               REPETITIVITE ',repetitivite,' jours');
       writeln(fichier);
       writeln(fichier,'                          Base de poursuite: ',nombase);
       str(elevmin:5:2,elevmintexte);writeln;
       writeln(fichier,'                    Elevation minimale pour contact TM-TC: ',elevmintexte,' degres');
       writeln(fichier);
       write(fichier,'                           **************************');
       writeln(fichier);
  END;

  PROCEDURE PREPARATIONTABLEUR;

      BEGIN
              
       write(fichierexcel,'STATION ',nombase,chr(13));
       str(elevmin:4:1,xelevmin);
       write(fichierexcel,'Elvation ',xelevmin,' degrs',chr(13));
       str(dureemin:4:0,xduree);
       write(fichierexcel,'Temps mini de liaison ',xduree,' sec',chr(13));
       write(fichierexcel,'Satellite: ',Nomsatellite,chr(13));
       write(fichierexcel,'Hliosynchronisme  ',heuresat,' heures',chr(13),chr(13));



       write(fichierexcel,'DATE',chr(9),'DEBUT',chr(9),'FIN',chr(9),
       'DUREE',chr(13),chr(13));

      END;

 (*PROGRAMME PRINCIPAL*)


 BEGIN

     DIALOGUE;

     ouverture(nom_fichier);

     EcritureDisque;
     preparationtableur;
     elevation_acceptable;

     ContactMoyen;

     close(fich);
     close(fichier);
     close(fichierexcel);
     clrscr;
     writeln('                             OUF J''AI FINI, A VOUS !!!');
     writeln;writeln;writeln;
     writeln('  Vous trouverez vos resultats dans le fichier----> ',fichierdisque);
     writeln;writeln;writeln;
     writeln('  De meme resultats pour tableur dans le fichier----> ',nom_fichier_tableur);
     writeln;writeln;writeln;
     writeln('                         Pour quitter appuyez sur une touche');
     ch:=readkey;

     DoneWinCrt;

END.
