PROGRAM Ter_Hall;

{ *****   PROGRAMME DE VOL HELIOCENTRIQUE DE LA TERRE VERS HALLEY ******}

uses Constype,Wincrt,Dates,fcxmars,fonvect,fctvenus,fctsaturne,halleyjj,halley,fctcomet;
VAR x,JJD,JJA,C3D,C3A,datir,distance,Nvitrel,possible:real;
    ch:char;
    vitdepart,vitarrivee,vitinfdep,vitinfar,vd,va,vitrel:vecteur;
    param:tabparam;
    conclusion:boolean;
    imprim:integer;
    r,v:vecteur;
    datedep, heuredep,datearriv,heurearriv:string;
BEGIN
    writeLn('               *****************************************');
    writeLn('               *  VOYAGE TERRE - HALLEY EN 1985 - 1986 *');
    writeLn('               *****************************************');
    writeLn;
    write('       Date dpart sous la forme (JJMMAAAAA) DateDpart = ');ReadLn(datedep);
    write('       Heure dpart sous la forme (HHMMSS) HeureDpart = ');ReadLn(heuredep);
    writeLn;
    write('       Date arrive sous la forme (JJMMAAAAA) DateArrive = ');ReadLn(datearriv);
    write('       Heure arrive sous la forme (HHMMSS) HeureArrive = ');ReadLn(heurearriv);
    writeLn;

    JJD:=jourjulien(datedep,heuredep);
    JJA:=jourjulien(datearriv,heurearriv);
  
    TERRE_HALLEY(JJD,JJA,C3D,vd,va,vitdepart,vitarrivee,vitinfdep,param,possible);

    vitrel[1]:=vitarrivee[1]-va[1];
    vitrel[2]:=vitarrivee[2]-va[2];
    vitrel[3]:=vitarrivee[3]-va[3];

    writeLn('                 **************************************');
    writeLn('                 *               RESULTATS            *');
    writeLn('                 **************************************');
    writeLn;
    writeLn('    Constante C3  l''infini de la Terre C3D = ',C3D:6:3,'  km/s  ');
    writeLn;
    writeLn('    Vitesse relative de croisement, VR = ',norm(vitrel):6:3,'  km/s');
    writeLn;
    writeLn('    Vitesse Terre au dpart :');
    writeLn('                    VT[1] = ',vd[1]:6:3,'  km/s');
    writeLn('                    VT[2] = ',vd[2]:6:3,'  km/s');
    writeLn('                    VT[1] = ',vd[3]:6:3,'  km/s');
    writeLn;
    writeLn('    Vitesse Giotto au dpart :');
    writeLn('                    V0G[1] = ',vitdepart[1]:6:3,'  km/s');
    writeLn('                    V0G[2] = ',vitdepart[2]:6:3,'  km/s');
    writeLn('                    V0G[1] = ',vitdepart[3]:6:3,'  km/s');
    writeLn;
    writeLn('    ***** NOTEZ CES RESULTATS, appuyez sur une touche pour ECRAN SUIVANT  *****');
    writeLn;
    ch:=readkey;
    writeLn('    Vitesse Halley  l''arrive :');
    writeLn('                    VH[1] = ',va[1]:6:3,'  km/s');
    writeLn('                    VH[2] = ',va[2]:6:3,'  km/s');
    writeLn('                    VH[1] = ',va[3]:6:3,'  km/s');
    writeLn;
    writeLn;
    writeLn('    Vitesse Giotto  l''arrive :');
    writeLn('                    V1G[1] = ',vitarrivee[1]:6:3,'  km/s');
    writeLn('                    V1G[2] = ',vitarrivee[2]:6:3,'  km/s');
    writeLn('                    V1G[1] = ',vitarrivee[3]:6:3,'  km/s');
    writeLn;
    writeLn('    ***** NOTEZ CES RESULTATS, appuyez sur une touche pour FINIR  *****');

    ch:=readkey;
    DoneWinCrt;

END.

