PROGRAM ENZTOIJK;

{***********************************************
 * 
 * calcule le changement de base IJK ---> ENZ
 *	r dans IJK  en km
 *	V dans IJK  en km/s
 
 *  connaissant
 *       r rayon vecteur initial dans ENZ
 *       V vitesse initiale absolue dans ENZ
 *       Alpha0 ascension droite de l'injection
 *       Lambda0 latitude initiale de l'injection
 *  
 ************************************************}


uses wincrt,windos,fonscal,fonvect,constype,matrice;

var r,V:vecteur;  {DONNEES DANS ENZ}
    
    chr:char;
    P:mat33;  {Matrice de passage de IJK a ENZ}


procedure DEMANDE;


BEGIN
writeln('     Donnez en km le rayon vecteur scalaire r=RT+Z '); writeln;
write('      r = ');readln(r[3]);
r[2]:=0;
r[1]:=0; writeln;writeln;


writeln('     Donnez en  km/s les composantes du vecteur vitesse absolue dans E, N, Z');

writeln;write('          V[1]= ');read(V[1]);
write('          V[2]= ');read(V[2]);
write('          V[3]= ');read(V[3]); writeln;writeln;
END;

procedure CALCUL_MATRICE;
var alpha0,lat:real;

BEGIN
writeln('     Donnez en degrs:');writeln;

write('          L''ascension droite alpha0 = L0+lg(t0) = ');read(alpha0);
write('          la latitude du point d''injection lambda0= ');read(lat);

lat:=lat*pi/180;
alpha0:=alpha0*pi/180;

{CALCUL DE LA MATRICE DE PASSAGE}

P[1,1]:=-sin(alpha0);P[1,2]:=-sin(lat)*cos(alpha0);
P[1,3]:= cos(lat)*cos(alpha0);P[2,1]:=cos(alpha0);
P[2,2]:= -sin(lat)*sin(alpha0);P[2,3]:=cos(lat)*sin(alpha0);
P[3,1]:=0;P[3,2]:=cos(lat); P[3,3]:=sin(lat);


END;


procedure CALCUL_R_V;

Var K:vecteur;
    inclin:real;

BEGIN
    prodmatvect(P,r,r);
   prodmatvect(P,V,V);
   writeln;writeln;
   Writeln('     VOICI LES COMPOSANTES DANS I,J,K DE LA POSITION-VITESSE (km et km/s');
   writeln;writeln;
   writeln('       r[1]= ',r[1]:6:2,'  km');
   writeln('       r[2]= ',r[2]:6:2,'  km');
   writeln('       r[3]= ',r[3]:6:2,'  km');
   writeln;
writeln;writeln;
   writeln('       V[1]= ',V[1]:8:5,'  km/s');
   writeln('       V[2]= ',V[2]:8:5,'  km/s');
   writeln('       V[3]= ',V[3]:8:5,'  km/s');
   writeln;
writeln;writeln;
END;



BEGIN
writeLn('     ***********************************************');
 writeLn('     * Calcule le changement de base ENZ ---> IJK');
 writeLn('     *       r dans IJK  en km');
 writeLn('     *       V dans IJK  en km/s');

 writeLn('     *  connaissant:');
 writeLn('     *       r rayon vecteur initial dans ENZ');
 writeLn('     *       V vitesse initiale absolue dans ENZ');
 writeLn('     *       Alpha0 ascension droite de l''injection');
 writeLn('     *       Lambda0 latitude initiale de l''injection');

 writeLn('     ************************************************');
DEMANDE;
CALCUL_MATRICE;
CALCUL_R_V;

Writeln('                  ***** NOTEZ VOS RESULTATS *****');Writeln;
Writeln('          ***** POUR QUITTER APPUYEZ SUR UNE TOUCHE ****');
chr:=readkey;

donewincrt;
END.

