program date_cal;

uses Wincrt;

type tableau12=array[0..11] of integer;

const nonbis:tableau12 =(31,59,90,120,151,181,212,243,273,304,334,365);
			bis:tableau12=(31,60,91,121,152,182,213,244,274,305,335,366);
			numeroJourNonbis:tableau12=(31,28,31,30,31,30,31,31,30,31,30,31);
			numeroJourbis:tableau12=(31,29,31,30,31,30,31,31,30,31,30,31);

VAR datejuli,joursrestants,temps:real;
		TotalJourMois,numero:tableau12;
		ch,reponse:char;
		bissex,i,k,annee,mois,jourmois,heure,minute,reste,
		seconde:integer;
		AnneeJulienne:Array[1970..2020] of real;
                CAS:integer;
label DEBUT;


BEGIN

 WriteLn('     ***********************************************************');
 WriteLn('     *     CALCUL DE LA DATE CALENDAIRE ENTRE 1970 ET 2020     *');
 WriteLn('     *       -10957.5 =< date julienne nouvelle <= +7305        *');
 WriteLn('     ***********************************************************');
 writeln;writeln;

 writeln('               CONVERSION DATE JULIENNE EN DATE NORMALE');
 writeln;writeln;writeln;
 WriteLn('     TROIS CAS DE DATE SONT POSSIBLES :');
 WriteLn('       1 - Date julienne nouvelle  partir de 1/1/2000 12 h ');
 WriteLn('       2 - Date julienne modifie  partir de 1/1/2000 0 h ');
 WriteLn('       3 - Date julienne ancienne o le 1/1/2000 12 h est JJ =JD-2451545 ');
 WriteLn;WriteLn;

DEBUT:
Write('     CHOIX DU CAS  1 ou 2 ou 3, votre choix cas = '); ReadLn(CAS);   WriteLn;

If (CAS-1)*(CAS-3)>0 then
   Begin
     WriteLn('    Erreur de choix du cas');
     GoTo DEBUT;
   end;

If CAS=1 then
  Begin
    write('     Donnez la date julienne nouvelle =');
    readln(datejuli);
  end;

If CAS=2 then
    Begin
      write('     Donnez la date julienne modifie =');readln(datejuli);
      datejuli:=datejuli-0.5;
    end;
If CAS=3 then
    Begin
    write('     Donnez la date julienne ancienne =');readln(datejuli);
    datejuli:=datejuli-2451545;
    end;

if ((datejuli>7305.5) or (datejuli<-10957.5)) then
 Begin
    WriteLn;
    writeLn('     Date hors des limites ??????');
    WriteLn;
    GoTo DEBUT;
 end;
writeln;writeln;

{Calcul de la date julienne des annees 1970  2020 , on rappelle
que le 01/01/2000 a 12 h est le jour julien 0, et que le 01/01/1970 12 h est JJ=-10957.5}

AnneeJulienne[1970]:= -10957.5;

For i:=1 to 50 do

	Begin

	{Test de l annee bissextile}

	 If ((1970+i-1) MOD(4))=0 then bissex:=1 else bissex:=0;

	 AnneeJulienne[1970+i]:=AnneeJulienne[1970+i-1]+365+BISSEX;

	End;

{Calcul preliminaire de la date julienne a zero heure}


{Calcul de l annee}

For i:=0 to 49 do

	Begin
                If abs(datejuli+10957.5)<0.5 then annee:=1970;

		if datejuli=AnneeJulienne[1970+i]+0.5 then
		 begin
			annee:=1970+i;
			k:=i;
		 end;

		If (datejuli<(AnneeJulienne[1970+i+1]+0.5)) and (datejuli>(AnneeJulienne[1970+i]+0.5))
		then
			 begin
			 annee:=1970+i;
			 k:=i;
		end;

		If datejuli=AnneeJulienne[2020]+0.5 then
			begin
				annee:=2020;
				k:=40;
			end;
               { WRITELN('    Anne= ',annee,' = ',1970+i,'N = ',AnneeJulienne[1970+i]);
                 ch:=readkey; }

	End;

{Calcul du mois de l annee}

JoursRestants:=Round(Int(datejuli-AnneeJulienne[1970+k]));


If (annee MOD(4)=0) then
	begin
		TotalJourMois:=bis;
		numero:=numeroJourbis;
	end

										else
	begin
		TotalJourMois:=nonbis;
		numero:=numeroJournonbis;
	end;

mois:=1;

	for i:=0 to 10 do

	begin

		if (JoursRestants<TotalJourMois[0])  then

			begin
				mois:=1;
				reste:=round(JoursRestants)+1;

			end;

		if JoursRestants=TotalJourMois[i] then
	begin
			 mois:=i+2;
			 reste:=1;
		 end;

		if (JoursRestants>TotalJourMois[i]) and (JoursRestants<TotalJourMois[i+1])
		then
      begin
			 mois:=i+2;
			 reste:=round(JoursRestants-TotalJourMois[i])+1;
      end;

		if (JoursRestants=TotalJourMois[i+1]) then
     begin
			mois:=i+2;
			reste:=numero[i];
		 end;

	end;

 {Calcul de l heure }

 temps:=frac(datejuli-0.5);
 if temps<0 then temps:=temps+1;

 heure:=round(Int(temps*24));
 temps:=(temps*24-heure)*60;
 minute:=round(Int(temps));
 temps:=(temps-minute)*60;
 seconde:=round(temps);

 writeln('                                 RESULTAT');

 writeln;writeln;
 WriteLn('     *********************************************************************');


 if (datejuli+0.5)*datejuli<0   then  writeln('    La date julienne ',datejuli,' est le ',31,'/',
 '12','/',1999,' a ' ,heure,' h ',minute,' mn ',seconde,' s');

 if (datejuli+0.5)*datejuli>=0then
 begin
 	writeln('     La date julienne ',datejuli,' est le ',reste,'/',
 	mois,'/',annee,' a ' ,heure,' h ',minute,' mn ',seconde,' s');
 end;

 WriteLn('     *********************************************************************');
 writeln;writeln;

 Write('     AVEZ-VOUS UNE AUTRE DATE A CONVERTIR (o/n), rponse ?'); readLn(reponse);
 If ((reponse='o') or (reponse='O') or (reponse='0')) then GoTo DEBUT ;
 WriteLn;
 writeln('     Pour fermer la fenetre appuyer sur une touche');
 {ch:=readkey; }
 DoneWinCrt;

END.