
											{UNITE..UNITE..UNITE..UNITE}

UNIT DJJ_NORM;

{Cette unite peut etre utilisee dans les programmes pour convertir
une date julienne en une date normale du calendrier republicain
actuel.


SON DOMAINE DE VALIDITE EST 01/01/1980 >>>>>>>>>01/01/2020


On rappelle que l origine 0 de la date julienne est le 01/01/2000
a 12 Heures.

Par exemple la date et heure 29/02/2004 11 h 23 mn, 45 s
est 1519.9748264 JJ

Le 14/01/1982 10 h 00 mn 00 s est -6561.0833333.}



{La variable d entree est DateJuli la date julienne (REAL)

Les variables de sortie sont des ENTIERS:

Annee,Mois,Jour,Heure,Minuten,Seconde}


INTERFACE

procedure ConversionDateJulienneNormale(var datejuli:real;var Jour,Mois,Annee,Heure,Minute,Seconde:integer);


IMPLEMENTATION

procedure ConversionDateJulienneNormale(var datejuli:real;var Jour,Mois,Annee,Heure,Minute,Seconde:integer);


type tableau12=array[0..11] of integer;

const nonbis:tableau12 =(31,59,90,120,151,181,212,243,273,304,334,
													365);
			bis:tableau12=(31,60,91,121,152,182,213,244,274,305,335,366);
			numeroJourNonbis:tableau12=(31,28,31,30,31,30,31,31,30,31,30
																,31);
			numeroJourbis:tableau12=(31,29,31,30,31,30,31,31,30,31,30,31);

VAR joursrestants,temps:real;
		TotalJourMois,numero:tableau12;
		ch:char;
		bissex,i,k,jourmois,reste:integer;
		AnneeJulienne:Array[1980..2020] of real;


BEGIN

{Calcul de la date julienne des annees 1980  2020 , on rappelle
que le 01/01/2000 a 12 h est le jour julien 0}

AnneeJulienne[1980]:= -7305.5;

For i:=1 to 40 do

	Begin

	{Test de l annee bissextile}

	 If ((1980+i-1) MOD(4))=0 then bissex:=1 else bissex:=0;

	 AnneeJulienne[1980+i]:=AnneeJulienne[1980+i-1]+365+BISSEX;

	End;
	{Calcul preliminaire de la date julienne a zero heure}


 {Calcul de l annee}

For i:=1 to 39 do

	Begin

		if datejuli=AnneeJulienne[1980+i]+0.5 then
		 begin
			annee:=1980+i;
			k:=i;
		 end;

		If (datejuli<(AnneeJulienne[1980+i+1]+0.5)) and
															(datejuli>(AnneeJulienne[1980+i]+0.5))
		then
			 begin
			 annee:=1980+i;
			 k:=i;
		end;

		If datejuli=AnneeJulienne[2020]+0.5 then
			begin
				annee:=2020;
				k:=40;
			end;

	End;

{Calcul du mois de l annee}

JoursRestants:=Round(Int(datejuli-AnneeJulienne[1980+k]));


If (annee MOD(4)=0) then
	begin
		TotalJourMois:=bis;
		numero:=numeroJourbis;
	end

										else
	begin
		TotalJourMois:=nonbis;
		numero:=numeroJournonbis;
	end;

	mois:=1;
	for i:=0 to 10 do

	begin

		if (JoursRestants<TotalJourMois[0])  then

			begin
				mois:=1;
				reste:=round(JoursRestants)+1;
			end;

		if JoursRestants=TotalJourMois[i] then
		 begin
			 mois:=i+1;
			 reste:=numero[i];
		 end;

		if (JoursRestants>TotalJourMois[i]) and
																(JoursRestants<TotalJourMois[i+1])
		then
			begin
			 mois:=i+2;
			 reste:=round(JoursRestants-TotalJourMois[i])+1;
			end;

		if (JoursRestants=TotalJourMois[i+1]) then
		 begin
			mois:=i+2;
			reste:=numero[i];
		 end;

	end;

	jour:=reste ;

 {Calcul de l heure }

 temps:=frac(datejuli-0.5);
 if temps<0 then temps:=temps+1;

 heure:=round(Int(temps*24));
 temps:=(temps*24-heure)*60;
 minute:=round(Int(temps));
 temps:=(temps-minute)*60;
 seconde:=round(temps);

END ;
END.